`timescale 1 ns / 1 ps
module LVDS71RX_1CLK8DATA 
(input wire alignwd
,input wire clk
,input wire clk_n
,input wire clk_s
,input wire init
,input wire phase_dir
,input wire phase_step
,input wire pll_reset
,input wire reset
,input wire [7:0] datain
,input wire [7:0] datain_n
,output wire lock
,output wire rx_ready
,output wire sclk
,output wire eclk
,output wire [6:0] clk_phase
,output wire [6:0] q0
,output wire [6:0] q1
,output wire [6:0] q2
,output wire [6:0] q3
,output wire [6:0] q4
,output wire [6:0] q5
,output wire [6:0] q6
,output wire [6:0] q7
,output wire clk_diff
);

wire opensync_0;
wire opensync_1;
wire opensync_cken;
wire opensync_2;
wire q6_7;
wire q5_7;
wire q4_7;
wire q3_7;
wire q2_7;
wire q1_7;
wire q0_7;
wire q6_6;
wire q5_6;
wire q4_6;
wire q3_6;
wire q2_6;
wire q1_6;
wire q0_6;
wire q6_5;
wire q5_5;
wire q4_5;
wire q3_5;
wire q2_5;
wire q1_5;
wire q0_5;
wire q6_4;
wire q5_4;
wire q4_4;
wire q3_4;
wire q2_4;
wire q1_4;
wire q0_4;
wire q6_3;
wire q5_3;
wire q4_3;
wire q3_3;
wire q2_3;
wire q1_3;
wire q0_3;
wire q6_2;
wire q5_2;
wire q4_2;
wire q3_2;
wire q2_2;
wire q1_2;
wire q0_2;
wire q6_1;
wire q5_1;
wire q4_1;
wire q3_1;
wire q2_1;
wire q1_1;
wire q0_1;
wire q6_0;
wire q5_0;
wire q4_0;
wire q3_0;
wire q2_0;
wire q1_0;
wire q0_0;
wire sclk_t;
wire cdiv1;
wire eclko;
wire xstop;
wire xstart;
wire opensync_3;
wire WBDATO0;
wire WBDATO1;
wire WBDATO2;
wire WBDATO3;
wire WBDATO4;
wire WBDATO5;
wire WBDATO6;
wire WBDATO7;
wire WBACK;
wire DPHSRC;
wire CLKINTFB;
wire REFCLK;
wire INTLOCK;
wire lock_chk;
wire CLKOS3;
wire CLKOS2;
wire clkos;
wire clkop;
wire scuba_vlo;
wire buf_clkop;
wire pllclki;
wire buf_clk;
wire buf_dataini7;
wire buf_dataini6;
wire buf_dataini5;
wire buf_dataini4;
wire buf_dataini3;
wire buf_dataini2;
wire buf_dataini1;
wire buf_dataini0;
reg [3:0] PSDA;
reg [3:0] DUTYDA;
reg [2:0] phase_step_vec=0;

assign scuba_vhi = 1'b1;
assign scuba_vlo = 1'b0;

assign eclk = eclko;

defparam LUT4_1.INIT =  16'h0a78 ;
LUT4 
LUT4_1 
(.I3(opensync_0)
,.I2(opensync_3)
,.I1(lock_chk)
,.I0(1)
,.F(opensync_cken)
);

defparam LUT4_0.INIT =  16'hfffe ;
LUT4 
LUT4_0 
(.I3(opensync_0)
,.I2(opensync_1)
,.I1(0)
,.I0(0)
,.F(xstop)
);

reg [3:0] opensync;
always@(posedge clk_s or posedge reset)
begin
  if(reset)
    opensync <= 4'b0001;
  else if(opensync_cken)
    opensync <= {opensync[2:0], opensync[3]};
end

assign {opensync_3, opensync_2, opensync_1, opensync_0} = opensync;

IVIDEO 
Inst8_IDDRX71A 
(.D(clk)
,.FCLK(eclko)
,.PCLK(sclk_t)
,.RESET(reset)
,.CALIB(alignwd)
,.Q0(clk_phase[0])
,.Q1(clk_phase[1])
,.Q2(clk_phase[2])
,.Q3(clk_phase[3])
,.Q4(clk_phase[4])
,.Q5(clk_phase[5])
,.Q6(clk_phase[6])
);

IVIDEO 
Inst7_IDDRX71A7 
(.D(buf_dataini7)
,.FCLK(eclko)
,.PCLK(sclk_t)
,.RESET(reset)
,.CALIB(alignwd)
,.Q0(q0_7)
,.Q1(q1_7)
,.Q2(q2_7)
,.Q3(q3_7)
,.Q4(q4_7)
,.Q5(q5_7)
,.Q6(q6_7)
);

IVIDEO 
Inst7_IDDRX71A6 
(.D(buf_dataini6)
,.FCLK(eclko)
,.PCLK(sclk_t)
,.RESET(reset)
,.CALIB(alignwd)
,.Q0(q0_6)
,.Q1(q1_6)
,.Q2(q2_6)
,.Q3(q3_6)
,.Q4(q4_6)
,.Q5(q5_6)
,.Q6(q6_6)
);

IVIDEO 
Inst7_IDDRX71A5 
(.D(buf_dataini5)
, .FCLK(eclko)
, .PCLK(sclk_t)
, .RESET(reset)
, .CALIB(alignwd)
, .Q0(q0_5)
, .Q1(q1_5)
, .Q2(q2_5)
, .Q3(q3_5)
, .Q4(q4_5)
, .Q5(q5_5)
, .Q6(q6_5)
);

IVIDEO 
Inst7_IDDRX71A4 
(.D(buf_dataini4)
,.FCLK(eclko)
,.PCLK(sclk_t) 
,.RESET(reset)
,.CALIB(alignwd)
,.Q0(q0_4)
,.Q1(q1_4)
,.Q2(q2_4)
,.Q3(q3_4)
,.Q4(q4_4)
,.Q5(q5_4)
,.Q6(q6_4)
);

IVIDEO 
Inst7_IDDRX71A3 
(.D(buf_dataini3)
,.FCLK(eclko)
,.PCLK(sclk_t)
,.RESET(reset)
,.CALIB(alignwd)
,.Q0(q0_3)
,.Q1(q1_3)
,.Q2(q2_3)
,.Q3(q3_3)
,.Q4(q4_3)
,.Q5(q5_3)
,.Q6(q6_3)
);

IVIDEO 
Inst7_IDDRX71A2 
(.D(buf_dataini2)
,.FCLK(eclko)
,.PCLK(sclk_t)
,.RESET(reset)
,.CALIB(alignwd)
,.Q0(q0_2)
,.Q1(q1_2)
,.Q2(q2_2)
,.Q3(q3_2)
,.Q4(q4_2)
,.Q5(q5_2)
,.Q6(q6_2)
);

IVIDEO 
Inst7_IDDRX71A1 
(.D(buf_dataini1)
,.FCLK(eclko)
,.PCLK(sclk_t)
,.RESET(reset)
,.CALIB(alignwd)
,.Q0(q0_1)
,.Q1(q1_1)
,.Q2(q2_1)
,.Q3(q3_1)
,.Q4(q4_1)
,.Q5(q5_1)
,.Q6(q6_1)
);

IVIDEO 
Inst7_IDDRX71A0 
(.D(buf_dataini0)
,.FCLK(eclko)
,.PCLK(sclk_t)
,.RESET(reset)
,.CALIB(alignwd)
,.Q0(q0_0)
,.Q1(q1_0)
,.Q2(q2_0)
,.Q3(q3_0)
,.Q4(q4_0)
,.Q5(q5_0)
,.Q6(q6_0)
);

defparam Inst6_CLKDIVC.DIV_MODE = "3.5" ;
CLKDIV 
Inst6_CLKDIVC 
(.RESETN(~reset)
,.HCLKIN(eclko)
,.CALIB(alignwd)
,.CLKOUT(sclk_t)
);

assign eclko = xstop ? 1'b0 : clkos;

always @(posedge clk_diff) begin
    phase_step_vec <= {phase_step_vec[1:0],phase_step};
end	

always @(posedge clk_diff or posedge reset) begin
	  if(reset) begin
	  	  PSDA <= 0;
	  	  DUTYDA <= 8;
	  end else if(phase_dir && phase_step_vec[2:1] == 2'b01) begin
	      PSDA <= PSDA + 1;
	      DUTYDA <= PSDA + 9; 
	  end else if(!phase_dir && phase_step_vec[2:1] == 2'b01) begin
	      PSDA <= PSDA - 1;
	      DUTYDA <= PSDA + 7;
	  end    	      
end

PLL 
pll_inst 
(.CLKOUT(clkop)
,.LOCK(lock_chk)
,.CLKOUTP(clkos)
,.CLKOUTD(CLKOS2)
,.CLKOUTD3(CLKOS3)
,.RESET(pll_reset)
,.RESET_P(scuba_vlo)
,.RESET_I(scuba_vlo)
,.RESET_S(scuba_vlo)
,.CLKIN(pllclki)
,.CLKFB(0)
,.FBDSEL(0)
,.IDSEL(0)
,.ODSEL(0)
,.PSDA(PSDA)
,.DUTYDA(DUTYDA)
,.FDLY(15)
);

defparam pll_inst.FCLKIN = "108";
defparam pll_inst.DYN_IDIV_SEL = "false";
defparam pll_inst.IDIV_SEL = 1;
defparam pll_inst.DYN_FBDIV_SEL = "false";
defparam pll_inst.FBDIV_SEL = 6;
defparam pll_inst.DYN_ODIV_SEL= "false";
defparam pll_inst.ODIV_SEL = 2;
defparam pll_inst.PSDA_SEL = "1111";
defparam pll_inst.DYN_DA_EN = "true";
defparam pll_inst.DUTYDA_SEL = "1000";
defparam pll_inst.CLKOUT_FT_DIR = 1'b1;
defparam pll_inst.CLKOUTP_FT_DIR = 1'b1;
defparam pll_inst.CLKOUT_DLY_STEP = 0;
defparam pll_inst.CLKOUTP_DLY_STEP = 0;
defparam pll_inst.CLKFB_SEL = "internal";
defparam pll_inst.CLKOUT_BYPASS = "false";
defparam pll_inst.CLKOUTP_BYPASS = "false";
defparam pll_inst.CLKOUTD_BYPASS = "false";
defparam pll_inst.DYN_SDIV_SEL = 2;
defparam pll_inst.CLKOUTD_SRC = "CLKOUT";
defparam pll_inst.CLKOUTD3_SRC = "CLKOUT";
defparam pll_inst.DEVICE = "GW2A-18"; 

assign buf_clk = clk;

//TLVDS_IBUF Inst1_IB8 (buf_clk, clk, clk_n);

TLVDS_IBUF Inst1_IB7 (buf_dataini7, datain[7], datain_n[7]);
                                                        
TLVDS_IBUF Inst1_IB6 (buf_dataini6, datain[6], datain_n[6]);
                                                    
TLVDS_IBUF Inst1_IB5 (buf_dataini5, datain[5], datain_n[5]);
                                              
TLVDS_IBUF Inst1_IB4 (buf_dataini4, datain[4], datain_n[4]);
                                              
TLVDS_IBUF Inst1_IB3 (buf_dataini3, datain[3], datain_n[3]);
                                              
TLVDS_IBUF Inst1_IB2 (buf_dataini2, datain[2], datain_n[2]);
                                              
TLVDS_IBUF Inst1_IB1 (buf_dataini1, datain[1], datain_n[1]);
                                               
TLVDS_IBUF Inst1_IB0 (buf_dataini0, datain[0], datain_n[0]);

assign sclk = sclk_t;
assign q7[6] = q6_7;
assign q7[5] = q5_7;
assign q7[4] = q4_7;
assign q7[3] = q3_7;
assign q7[2] = q2_7;
assign q7[1] = q1_7;
assign q7[0] = q0_7;
assign q6[6] = q6_6;
assign q6[5] = q5_6;
assign q6[4] = q4_6;
assign q6[3] = q3_6;
assign q6[2] = q2_6;
assign q6[1] = q1_6;
assign q6[0] = q0_6;
assign q5[6] = q6_5;
assign q5[5] = q5_5;
assign q5[4] = q4_5;
assign q5[3] = q3_5;
assign q5[2] = q2_5;
assign q5[1] = q1_5;
assign q5[0] = q0_5;
assign q4[6] = q6_4;
assign q4[5] = q5_4;
assign q4[4] = q4_4;
assign q4[3] = q3_4;
assign q4[2] = q2_4;
assign q4[1] = q1_4;
assign q4[0] = q0_4;
assign q3[6] = q6_3;
assign q3[5] = q5_3;
assign q3[4] = q4_3;
assign q3[3] = q3_3;
assign q3[2] = q2_3;
assign q3[1] = q1_3;
assign q3[0] = q0_3;
assign q2[6] = q6_2;
assign q2[5] = q5_2;
assign q2[4] = q4_2;
assign q2[3] = q3_2;
assign q2[2] = q2_2;
assign q2[1] = q1_2;
assign q2[0] = q0_2;
assign q1[6] = q6_1;
assign q1[5] = q5_1;
assign q1[4] = q4_1;
assign q1[3] = q3_1;
assign q1[2] = q2_1;
assign q1[1] = q1_1;
assign q1[0] = q0_1;
assign q0[6] = q6_0;
assign q0[5] = q5_0;
assign q0[4] = q4_0;
assign q0[3] = q3_0;
assign q0[2] = q2_0;
assign q0[1] = q1_0;
assign q0[0] = q0_0;
assign rx_ready = xstart;
assign xstart = opensync_3;
assign lock = lock_chk;
assign pllclki = buf_clk;
assign clk_diff = buf_clk;

endmodule