`timescale 1ns/1ps
module fifo48b_24b 
(input wr_clk
,input rd_clk
,input rst_n
,input [47:0] wr_data
,input wr_en
,output [23:0] rd_data
,input rd_en
);
reg [7:0] mem [0:59];
reg [7:0] wr_ptr;
reg full_r;
reg [23:0] rd_data_r;
reg [7:0] rd_ptr;
reg empty_r;
integer i;

assign rd_data = rd_data_r;

always @(posedge wr_clk or negedge rst_n) begin
    if(!rst_n) begin  	
    	  for(i=0;i<60;i=i+1) begin  
    	      mem[i] <= 'b0;    	  
    	  end
    end else if(wr_en) begin
    	  mem[wr_ptr]   <= wr_data[47:40]; 
    	  mem[wr_ptr+1] <= wr_data[39:32]; 
    	  mem[wr_ptr+2] <= wr_data[31:24];
    	  mem[wr_ptr+3] <= wr_data[23:16]; 
    	  mem[wr_ptr+4] <= wr_data[15:8]; 
    	  mem[wr_ptr+5] <= wr_data[7:0];
    end		
end

always @(posedge wr_clk or negedge rst_n) begin
    if(!rst_n) begin
    	  wr_ptr <= 'b0;
    end else if(wr_en) begin
    	  wr_ptr <= wr_ptr == 60 ? 0 : wr_ptr + 6;
    end		
end

always @(posedge rd_clk or negedge rst_n) begin
    if(!rst_n) begin
    	  rd_data_r <= 'b0;
    end else if(rd_en) begin
    	  rd_data_r <= {mem[rd_ptr+2],mem[rd_ptr+1],mem[rd_ptr]};
    end		
end

always @(posedge rd_clk or negedge rst_n) begin
    if(!rst_n) begin
    	  rd_ptr <= 'b0;
    end else if(rd_en) begin
    	  rd_ptr <= rd_ptr == 60 ? 0 : rd_ptr + 3;
    end		
end

endmodule