module word_align_ctl 
(input   wire        clk            // clock -> sclk
,input   wire        rst            // asynchronous reset
,input   wire  [6:0] clock_word     // deserializer (IDDRX71) output
,input   wire        align_enable   // ciruit enable
,output  reg         slip           // slip command to deserializer
);

reg     [2:0]   count;          // counter

always @ (posedge clk or posedge rst)
    if (rst) begin   
        count <= 0;
    end else begin
        if (!align_enable)
            count <= 0;
        else
            count <= count + 1;
    end

always @ (posedge clk or posedge rst)
    if (rst) begin   
        slip <= 0;
    end else begin
        if((count == 1) && (clock_word != 7'b1100011)) begin
            slip <= 1;
        end else if((count == 3) || !align_enable) begin
            slip <= 0;
        end
    end

endmodule
