`timescale 1ns/1ps
module tb;
reg clk_link;
reg rst_n;
reg clk_g;
reg [7:0] rxdata = 8'ha5;
wire TCLK0_out;
wire [5:0] TDAT0_out;
wire TCLK0_out_n;
wire [5:0] TDAT0_out_n;
wire TCLK1_out;
wire [5:0] TDAT1_out;
wire TCLK1_out_n;
wire [5:0] TDAT1_out_n;
wire TCLK2_out;
wire [5:0] TDAT2_out;
wire TCLK2_out_n;
wire [5:0] TDAT2_out_n;
wire TCLK3_out;
wire [5:0] TDAT3_out;
wire TCLK3_out_n;
wire [5:0] TDAT3_out_n;
// Status/Debug ports
wire [3:0] LED;

initial begin
	  clk_link = 1'b0;
	  forever #5 clk_link = ~clk_link;
end	

initial begin
	  clk_g = 1'b0;
      #2
	  forever #10 clk_g = ~clk_g;
end	

GSR GSR (.GSRI(1));

always @(posedge clk_g) begin
	  rxdata <= ~rxdata;
end	

initial begin
	  rst_n = 1'b0;
	  #100
	  rst_n = 1'b1;
end	


initial begin
    $fsdbDumpfile("lvds71_41TX.fsdb");
    $fsdbDumpvars;
end

lvds71_lvds41_top u_top(
    .GSRN        (rst_n)
    ,.RCLK_in     (clk_link)
    ,.RA_in       (rxdata[0])
    ,.RB_in       (rxdata[1])
    ,.RC_in       (rxdata[2])
    ,.RD_in       (rxdata[3])
    ,.RE_in       (rxdata[4])
    ,.RF_in       (rxdata[5])
    ,.RG_in       (rxdata[6])
    ,.RH_in       (rxdata[7])
    ,.RCLK_in_n   (~clk_link)
    ,.RA_in_n     (~rxdata[0])
    ,.RB_in_n     (~rxdata[1])
    ,.RC_in_n     (~rxdata[2])
    ,.RD_in_n     (~rxdata[3])
    ,.RE_in_n     (~rxdata[4])
    ,.RF_in_n     (~rxdata[5])
    ,.RG_in_n     (~rxdata[6])
    ,.RH_in_n     (~rxdata[7])
    ,.TCLK0_out   (TCLK0_out)
    ,.TDAT0_out   (TDAT0_out)
    ,.TCLK0_out_n (TCLK0_out_n)
    ,.TDAT0_out_n (TDAT0_out_n)
    ,.TCLK1_out   (TCLK1_out)
    ,.TDAT1_out   (TDAT1_out)
    ,.TCLK1_out_n (TCLK1_out_n)
    ,.TDAT1_out_n (TDAT1_out_n)
    ,.TCLK2_out   (TCLK2_out)
    ,.TDAT2_out   (TDAT2_out)
    ,.TCLK2_out_n (TCLK2_out_n)
    ,.TDAT2_out_n (TDAT2_out_n)
    ,.TCLK3_out   (TCLK3_out)
    ,.TDAT3_out   (TDAT3_out)
    ,.TCLK3_out_n (TCLK3_out_n)
    ,.TDAT3_out_n (TDAT3_out_n)
    ,.LED         (LED)  
);
initial begin
	  clk_link = 1'b0;
		#1000;
		#50000;
		#200000;
        #2000000;
        $finish;
end


endmodule
